// Code generated by gowrap. DO NOT EDIT.
// template: ../../assets/templates/middleware/access_log.tmpl
// gowrap: http://github.com/hexdigest/gowrap

package middleware

//go:generate gowrap gen -p git.perx.ru/perxis/perxis-go/logs -i Service -t ../../assets/templates/middleware/access_log.tmpl -o logging_middleware.go -l ""

import (
	"context"
	"time"

	"git.perx.ru/perxis/perxis-go/logs"
	"git.perx.ru/perxis/perxis-go/pkg/auth"
	"go.uber.org/zap"
)

// accessLoggingMiddleware implements logs.Service that is instrumented with logging
type accessLoggingMiddleware struct {
	logger *zap.Logger
	next   logs.Service
}

// AccessLoggingMiddleware instruments an implementation of the logs.Service with simple logging
func AccessLoggingMiddleware(logger *zap.Logger) Middleware {
	return func(next logs.Service) logs.Service {
		return &accessLoggingMiddleware{
			next:   next,
			logger: logger,
		}
	}
}

func (m *accessLoggingMiddleware) Delete(ctx context.Context, filter *logs.Filter) (err error) {
	begin := time.Now()

	m.logger.Debug("Delete.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("filter", filter),
	)

	err = m.next.Delete(ctx, filter)

	m.logger.Debug("Delete.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}

func (m *accessLoggingMiddleware) Find(ctx context.Context, filter *logs.Filter, options *logs.FindOptions) (fp1 *logs.FindResult, err error) {
	begin := time.Now()

	m.logger.Debug("Find.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("filter", filter),
		zap.Reflect("options", options),
	)

	fp1, err = m.next.Find(ctx, filter, options)

	m.logger.Debug("Find.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Reflect("fp1", fp1),
		zap.Error(err),
	)

	return fp1, err
}

func (m *accessLoggingMiddleware) Log(ctx context.Context, entries []*logs.Entry) (err error) {
	begin := time.Now()

	m.logger.Debug("Log.Request",
		zap.Reflect("principal", auth.GetPrincipal(ctx)),
		zap.Reflect("entries", entries),
	)

	err = m.next.Log(ctx, entries)

	m.logger.Debug("Log.Response",
		zap.Duration("time", time.Since(begin)),
		zap.Error(err),
	)

	return err
}
