package transportgrpc

import (
	grpcerr "git.perx.ru/perxis/perxis-go/pkg/errors/grpc"
	"git.perx.ru/perxis/perxis-go/pkg/organizations"
	"git.perx.ru/perxis/perxis-go/pkg/organizations/transport"
	pb "git.perx.ru/perxis/perxis-go/proto/organizations"
	grpckit "github.com/go-kit/kit/transport/grpc"
)

func NewServer(svc organizations.Organizations, opts ...grpckit.ServerOption) pb.OrganizationsServer {
	eps := transport.Endpoints(svc)
	eps = transport.EndpointsSet{
		CreateEndpoint: grpcerr.ServerMiddleware(eps.CreateEndpoint),
		DeleteEndpoint: grpcerr.ServerMiddleware(eps.DeleteEndpoint),
		FindEndpoint:   grpcerr.ServerMiddleware(eps.FindEndpoint),
		GetEndpoint:    grpcerr.ServerMiddleware(eps.GetEndpoint),
		UpdateEndpoint: grpcerr.ServerMiddleware(eps.UpdateEndpoint),
	}
	return NewGRPCServer(&eps, opts...)
}
